org 100h        ; assume dx=cs>=768 bp~0x912 si=0x100

  mov ax,0x4f02 ; [si]: D = -0.00315873139 (float32 0xbb4f02b8)
  mov bx,105h   ; VESA mode 1024x768, 256 colors
;  mov bx,107h   ; VESA mode 1280x1024, 256 colors

  fldl2e        ;; y=1.44
  mov dh,3      ; dx >= 768
;  mov dh,4      ; dx >= 1024
Y fldln2        ;; x=0.693 y
  mov ch,4      ; cx = 1279 on init, = 1024 afterwards
;  mov ch,5      ; cx = 1534 on init, = 1280 afterwards
X int 10h       ; set mode or put pixel
                ; BIOS put pixel - ah=0xc bh:page=1 dx:y cx:x al:color=128..255|0
                ; (hope bh:page is ignored in VESA modes)

  mov ax,0x0c7f ; max 129 iterations

; 3x: duplicate and swap two stack items
D fld st0
  fld st2       ;; i=y r=x x y  | i r r i i r x y
I inc si
  jpo D         ; si=0x103

; (r, i) = (rr-ii+x, 2ri+y)
M fmulp st3,st0
  dec si
  jpo M         ;; ii ri rr x y   ; si=0x100
  
  fld st2
  fadd st1
  fistp word[bp+si] ; store round_even(rr+ii)

  fsub st3      ;; ii-x ri rr x y
  fsubp st2,st0 ;; ri rr-ii+x x y

  fadd st0      ;; 2ri rr-ii+x x y
  fadd st3      ;; 2ri+y rr-ii+x x y

  cmp ah,[bp+si]; cf: 12 < round_even(rr+ii) ... magnitude > 3.536
  inc al        ; zf: al == 0
  jnbe I        ; stop if al==0 or magnitude>3.536
                ; jump to do only 2 iterations of the D loop

  fcompp        ;; x y
  fadd dword[si];; x+=D y
  loop X

  fstp st0
  fadd dword[si];; y+=D
  dec dx
  jns Y
  ret
