org 100h        ; assume bp~0x912 si=0x100 cl=0xff

  mov ax,0x4f02 ; [si]: D = -0.00315873139 (float32 0xbb4f02b8)
;  mov bx,105h   ; VESA mode 1024x768, 256 colors
  mov bx,107h   ; VESA mode 1280x1024, 256 colors

  fldl2e        ;; y=1.44
;  mov dh,3      ; dx in 768..1023
;  mov dh,4      
  mov dx,0x4D8   ; dx = 1240  ; D8 04 = fadd dword[si]
Y ;fadd dword[si];; y+=D
  fldln2        ;; x=0.693 y
;  mov ch,4      ; cx = 1279 on init, 1024 afterwards
  mov ch,5      ; cx = 1534 on init, 1280 afterwards
;  mov cx,0x4D8   ; cx = 1240  ; D8 04 = fadd dword[si]
X fadd dword[si];; x+=D y
  int 10h       ; set mode or put pixel
                ; BIOS put pixel - ah=0xc bh:page=1 dx:y cx:x al:color=128..255|0
                ; (hope it works in VESA modes and bh:page is ignored)

  mov ax,0x0c7f ; al: max 129 iterations

; 3x: duplicate two values on the stack and swap them
D fld st0
  fld st2       ;; i=y r=x x y
I inc si
  jpo D         ;; i r r i i r x y  ; si=0x103

M fmulp st3,st0 ;; r r ii i r x y
  dec si        ;; r ii ri r x y
  jpo M         ;; ii ri rr x y     ; si=0x100

; Mandelbrot iteration: r, i = rr-ii+x, 2ri+y
  fld st2
  fadd st1
  fistp word[bp+si] ; <- round_even(rr+ii)

  fsub st3      ;; ii-x ri rr x y
  fsubp st2,st0 ;; ri rr-ii+x x y
  fadd st0      ;; 2ri rr-ii+x x y
  fadd st3      ;; 2ri+y rr-ii+x x y

  cmp ah,[bp+si]; cf: 12 < round_even(rr+ii) ... magnitude > 3.5355
  inc al        ; zf: al == 0
  jnbe I        ; stop if al == 0 or magnitude > 3.5355
                ; do the D loop only 2x

  fcompp        ;; x y
  loop X

  fcomp st1
  dec dx
  jns Y-2
  ret
